importScripts('https://www.gstatic.com/firebasejs/3.9.0/firebase-app.js');
importScripts('https://www.gstatic.com/firebasejs/3.9.0/firebase-messaging.js');

firebase.initializeApp({
  'messagingSenderId': '84260263282'
});

const messaging = firebase.messaging();

var data;
var user_action;
messaging.setBackgroundMessageHandler(function (payload) {
  
  // Customize notification here
  var body = payload.data.notification_body;
  const notificationTitle = payload.data.notification_title || 'Title';
  const notificationOptions = {
    body: body || 'Body',
    icon: 'assets/images/1.jpg'
  };

  data = payload.data.query_params || {};
  user_action = payload.data.notification_click_action;

  return self.registration.showNotification(notificationTitle,
    notificationOptions);
});

self.addEventListener('notificationclick', function (event) {

  event.waitUntil(clients.matchAll({
    type: "window"
  }).then(function (clientList) {
    for (var i = 0; i < clientList.length; i++) {
      var client = clientList[i];
      if (client.url == '/' && 'focus' in client)
        return client.focus();
    }
    if (clients.openWindow) {
      var query_params = '';
      var d = JSON.parse(data);
      Object.keys(d).forEach(function (key) {
        query_params += key + '=' + d[key] + '&';
      });

      // removing last '&' from query string added in loop above.
      query_params = query_params.substr(0, query_params.length - 1);

      var url = 'https://qa.erpdnhiggins.com/' + user_action + '?' + query_params;
      // var url = 'http://localhost:4200/' + user_action + '?' + query_params;
      return clients.openWindow(url);
    }
  }));
});